@use '../settings/vars' as vars;
@use '../tools/mixin_mq' as mixin_mq;

.container {
    width: 100%;
    margin-right: auto;
    margin-left: auto;
    padding-left: 16px;
    padding-right: 16px;
}

.gs\:grid {
    display: flex;
    flex-wrap: wrap;
    margin-right: -16px;
    margin-left: -16px;
}

[class*=col-],
.col{
    position: relative;
    width: 100%;
    padding-right: 16px;
    padding-left: 16px;
}

@mixin make-grid-system($s) {    
    #{$s}col {
        position: relative;
        width: 100%;
        padding-right: 16px;
        padding-left: 16px;
        flex-basis: 0;
        flex-grow: 1;
        max-width: 100%;
    }

    @for $i from 1 through 24 {
        #{$s}col-#{$i}{ 
            flex: 0 0 calc((100% / 24) * #{$i});
            max-width: calc((100% / 24) * #{$i});
        }
    }

    @for $i from 1 through 23 {
        #{$s}offset-#{$i}{
            margin-left: calc((100% / 24) * #{$i});
        }
    }

    @for $gap from 0 through 16 {
        #{$s}gs\:gap-#{$gap}{
            margin-left: -#{$gap * 0.125}rem;
            margin-right: -#{$gap * 0.125}rem;
        
            & > [class*=col-],
            & > .col{
                padding-right: #{$gap * 0.125}rem;
                padding-left: #{$gap * 0.125}rem;
            }
        }
    }
}

@include make-grid-system('.');

@each $breakpoint, $size in vars.$breakpoints {
    @include mixin_mq.media-up($breakpoint){
        .#{$breakpoint}\:{
            @include make-grid-system('&');
        }
    }
}